<template>
  <div id="tags-view-container" class="tags-view-container">
    <scroll-pane
      ref="scrollPane"
      class="tags-view-wrapper"
      @scroll="handleScroll"
    >
      <router-link
        v-for="tag in visitedViews"
        ref="tag"
        :key="tag.path"
        :class="isActive(tag) ? 'active' : ''"
        :to="{ path: tag.path, query: tag.query, fullPath: tag.fullPath }"
        tag="span"
        class="tags-view-item"
        @click.middle.native="!isAffix(tag) ? closeSelectedTag(tag) : ''"
        @contextmenu.prevent.native="openMenu(tag, $event)"
      >
        <span
          v-if="!isAffix(tag)"
          class="el-icon-close"
          @click.prevent.stop="closeSelectedTag(tag)"
        />
        <span v-else class="el-icon-close-else" />
        <span>{{ tag.meta.title ? tag.meta.title : tag.title }}</span>
      </router-link>
    </scroll-pane>
    <ul
      v-show="visible"
      :style="{ left: left + 'px', top: top + 'px' }"
      class="contextmenu"
    >
      <li @click="refreshSelectedTag(selectedTag)">
        <i class="el-icon-refresh-right"></i> 刷新页面
      </li>
      <li v-if="!isAffix(selectedTag)" @click="closeSelectedTag(selectedTag)">
        <i class="el-icon-close"></i> 关闭当前
      </li>
      <li @click="closeOthersTags">
        <i class="el-icon-circle-close"></i> 关闭其他
      </li>
      <li v-if="!isFirstView()" @click="closeLeftTags">
        <i class="el-icon-back"></i> 关闭左侧
      </li>
      <li v-if="!isLastView()" @click="closeRightTags">
        <i class="el-icon-right"></i> 关闭右侧
      </li>
      <li @click="closeAllTags(selectedTag)">
        <i class="el-icon-circle-close"></i> 全部关闭
      </li>
    </ul>
  </div>
</template>

<script>
import ScrollPane from "./ScrollPane";
import path from "path";
import { getCompanyId, getMenuNode } from "@/utils/auth";
import { ChangeCompany } from "@/api/apis/auth";
export default {
  components: {
    ScrollPane,
  },
  data() {
    return {
      visible: false,
      top: 0,
      left: 0,
      selectedTag: {},
      affixTags: [],
      visitedViews: [],
    };
  },
  computed: {
    routes() {
      return this.$store.state.permission.routes;
    },
    theme() {
      return this.$store.state.settings.theme;
    },
    companyID() {
      return this.$store.state.user.companyID;
    },
  },
  watch: {
    "$store.getters.currentMenuNode": {
      deep: true,
      immediate: true,
      handler(newVal, old) {
        this.visitedViews = this.getVisitedViews();
      },
    },
    $route() {
      this.addTags();
      this.moveToCurrentTag();
    },
    visible(value) {
      if (value) {
        document.body.addEventListener("click", this.closeMenu);
      } else {
        document.body.removeEventListener("click", this.closeMenu);
      }
    },
    companyID: {
      deep: true, //深度监听设置为 true
      handler: function (newV, oldV) {
        if (newV) {
          this.ChangeCompany(newV);
          this.$vmNews("切换公司成功", "success");
          this.closeAllTags(this.closeAllTags);
        }
      },
    },
  },
  mounted() {
    // this.initTags();
    // this.addTags();
  },
  methods: {
    getVisitedViews() {
      let url = getMenuNode();
      let currentData = [];
      let data = this.$store.state.tagsView.visitedViews || [];
      if (url) {
        if (url.includes("Workbench")) {
          currentData = data[0];
        } else if (url.includes("MasterDataCenter")) {
          currentData = data[1];
        } else if (url.includes("IntegrationTaskCenter")) {
          currentData = data[2];
        } else if (url.includes("businessCenter")) {
          currentData = data[3];
        } else if (url.includes("ApplicationCenter")) {
          currentData = data[4];
        } else {
          currentData = [];
        }
      } else {
        currentData = [];
      }
      return currentData;
    },
    async ChangeCompany(CompanyID) {
      let params = {
        CompanyID: CompanyID,
      };
      let res = await ChangeCompany(params);
    },
    isActive(route) {
      return route.path === this.$route.path;
    },
    activeStyle(tag) {
      if (!this.isActive(tag)) return {};
      return {
        "background-color": this.theme,
        "border-color": this.theme,
      };
    },
    isAffix(tag) {
      return tag.meta && tag.meta.affix;
    },
    isFirstView() {
      try {
        return (
          this.selectedTag.fullPath === this.visitedViews[1].fullPath ||
          this.selectedTag.fullPath === "/index"
        );
      } catch (err) {
        return false;
      }
    },
    isLastView() {
      try {
        return (
          this.selectedTag.fullPath ===
          this.visitedViews[this.visitedViews.length - 1].fullPath
        );
      } catch (err) {
        return false;
      }
    },
    filterAffixTags(routes, basePath = "/") {
      let tags = [];
      routes.forEach((route) => {
        if (route.meta && route.meta.affix) {
          const tagPath = path.resolve(basePath, route.path);
          tags.push({
            fullPath: tagPath,
            path: tagPath,
            name: route.name,
            id: route.id ? route.id : 0,
            meta: {
              ...route.meta,
            },
          });
        }
        if (route.children) {
          const tempTags = this.filterAffixTags(route.children, route.path);
          if (tempTags.length >= 1) {
            tags = [...tags, ...tempTags];
          }
        }
      });
      return tags;
    },
    initTags() {
      const affixTags = (this.affixTags = this.filterAffixTags(this.routes));
      console.log(affixTags,"affixTags")
      for (const tag of affixTags) {
        // Must have tag name
        if (tag.name) {
          this.$store.dispatch("tagsView/addVisitedView", tag);
        }
      }
    },
    addTags() {
      const name = this.$route.meta.title;
      // this.$route.meta.noCache = false
      if (name) {
        this.$store.dispatch("tagsView/addView", this.$route);
        if (this.$route.meta && this.$route.meta.link) {
          this.$store.dispatch("tagsView/addIframeView", this.$route);
        }
      }
      return false;
    },
    moveToCurrentTag() {
      const tags = this.$refs.tag;
      this.$nextTick(() => {
        for (const tag of tags) {
          if (tag.to.path === this.$route.path) {
            this.$refs.scrollPane.moveToTarget(tag);
            // when query is different then update
            if (tag.to.fullPath !== this.$route.fullPath) {
              this.$store.dispatch("tagsView/updateVisitedView", this.$route);
            }
            break;
          }
        }
      });
    },
    refreshSelectedTag(view) {
      this.$tab.refreshPage(view);
      if (this.$route.meta && this.$route.meta.link) {
        this.$store.dispatch("tagsView/delIframeView", this.$route);
      }
    },
    closeSelectedTag(view) {
      this.$tab.closePage(view).then(({ visitedViews }) => {
        let url = getMenuNode();
        let currentData = [];
        let data = visitedViews;
        if (url) {
          if (url.includes("Workbench")) {
            currentData = data[0];
          } else if (url.includes("MasterDataCenter")) {
            currentData = data[1];
          } else if (url.includes("IntegrationTaskCenter")) {
            currentData = data[2];
          } else if (url.includes("businessCenter")) {
            currentData = data[3];
          } else if (url.includes("ApplicationCenter")) {
            currentData = data[4];
          }
        }
        if (this.isActive(view)) {
          this.toLastView(currentData, view);
        }
      });
    },
    closeRightTags() {
      this.$tab.closeRightPage(this.selectedTag).then((visitedViews) => {
        let url = getMenuNode();
        let INDEX = null;
        if (url) {
          if (url.includes("Workbench")) {
            INDEX = 0;
          } else if (url.includes("MasterDataCenter")) {
            INDEX = 1;
          } else if (url.includes("IntegrationTaskCenter")) {
            INDEX = 2;
          } else if (url.includes("businessCenter")) {
            INDEX = 3;
          } else if (url.includes("ApplicationCenter")) {
            INDEX = 4;
          }
        }

        if (INDEX != null) {
          if (
            !visitedViews[INDEX].find(
              (i) => i.fullPath === this.$route.fullPath
            )
          ) {
            this.toLastView(visitedViews[INDEX]);
          }
          this.visitedViews = this.getVisitedViews();
        }
      });
    },
    closeLeftTags() {
      this.$tab.closeLeftPage(this.selectedTag).then((visitedViews) => {
        let url = getMenuNode();
        let INDEX = null;
        if (url) {
          if (url.includes("Workbench")) {
            INDEX = 0;
          } else if (url.includes("MasterDataCenter")) {
            INDEX = 1;
          } else if (url.includes("IntegrationTaskCenter")) {
            INDEX = 2;
          } else if (url.includes("businessCenter")) {
            INDEX = 3;
          } else if (url.includes("ApplicationCenter")) {
            INDEX = 4;
          }
        }
        if (INDEX != null) {
          if (
            !visitedViews[INDEX].find(
              (i) => i.fullPath === this.$route.fullPath
            )
          ) {
            this.toLastView(visitedViews[INDEX]);
          }
          this.visitedViews = this.getVisitedViews();
        }
      });
    },
    closeOthersTags() {
      this.$router.push(this.selectedTag).catch(() => {});
      this.$tab.closeOtherPage(this.selectedTag).then(() => {
        this.moveToCurrentTag();
        this.visitedViews = this.getVisitedViews();
      });
    },
    closeAllTags(view) {
      this.$tab.closeAllPage().then(({ visitedViews }) => {
        let url = getMenuNode();
        let INDEX = null;
        if (url) {
          if (url.includes("Workbench")) {
            INDEX = 0;
          } else if (url.includes("MasterDataCenter")) {
            INDEX = 1;
          } else if (url.includes("IntegrationTaskCenter")) {
            INDEX = 2;
          } else if (url.includes("businessCenter")) {
            INDEX = 3;
          } else if (url.includes("ApplicationCenter")) {
            INDEX = 4;
          }
        }
        if (INDEX != null) {
          if (this.affixTags.some((tag) => tag.path === this.$route.path)) {
            return;
          }
          this.toLastView(visitedViews[INDEX], view);
          this.visitedViews = this.getVisitedViews();
        }
      });
    },
    toLastView(visitedViews, view) {
      const latestView = visitedViews.slice(-1)[0];
      if (latestView) {
        this.$router.push(latestView.fullPath);
      } else {
        // now the default is to redirect to the home page if there is no tags-view,
        // you can adjust it according to your needs.
        if (view.name === "Dashboard") {
          // to reload home page
          this.$router.replace({
            path: "/redirect" + view.fullPath,
          });
        } else {
          this.$router.push("/");
        }
      }
    },
    openMenu(tag, e) {
      const menuMinWidth = 105;
      const offsetLeft = this.$el.getBoundingClientRect().left; // container margin left
      const offsetWidth = this.$el.offsetWidth; // container width
      const maxLeft = offsetWidth - menuMinWidth; // left boundary
      const left = e.clientX - offsetLeft + 15; // 15: margin right

      if (left > maxLeft) {
        this.left = maxLeft;
      } else {
        this.left = left;
      }
      if (this.newVersionSystem) {
        this.top = e.clientY;
      } else {
        this.top = e.clientY - 40;
      }

      this.visible = true;
      this.selectedTag = tag;
    },
    closeMenu() {
      this.visible = false;
    },
    handleScroll() {
      this.closeMenu();
    },
  },
};
</script>

<style lang="scss" scoped>
::v-deep .tags-view-wrapper .tags-view-item.active::before {
  content: "";
  width: unset !important;
  height: unset !important;
  margin-right: unset !important;
}

.tags-view-container {
  // height: 34px;
  width: calc(100% - 133px);
  // width: calc(100% - 180px);
  margin-left: 10px;
  background: #fff !important;
  border-radius: 4px;
  padding: 0px 10px;
  // border-bottom: 1px solid #d8dce5;
  // box-shadow: 0 1px 3px 0 rgba(0, 0, 0, .12), 0 0 3px 0 rgba(0, 0, 0, .04);
  position: fixed;
  top: 10px;
  // margin-top: 60px;
  z-index: 1000;

  .tags-view-wrapper {
    .tags-view-item {
      display: inline-block;
      position: relative;
      cursor: pointer;
      height: 35px;
      line-height: 35px;
      // border-right: 1px solid #d8dce5;
      color: #495060;
      // background: #fff;
      padding: 0 15px;
      font-size: 12px;
      margin: 4px 10px;
      text-align: center !important;
      font-family: PingFangSC, PingFang SC;
      font-weight: 400;
      font-size: 14px;
      color: #333333;
      font-style: normal;

      &:first-of-type {
        // margin-left: 15px;
      }

      &:last-of-type {
        margin-right: 15px;
      }

      &::after {
        content: "";
        background: #e4e3e3;
        display: inline-block;
        position: absolute;
        top: 50%;
        transform: translateY(-50%);
        right: -10px;
        width: 1px;
        height: 15px;
        margin-left: 8px;
        vertical-align: -3px;
      }

      &.active {
        //background-color: #42b983;
        color: #fff;
        border-color: #42b983;
        text-align: center !important;

        &::before {
          content: "";
          background: #fff;
          display: inline-block;
          width: 8px;
          height: 8px;
          border-radius: 50%;
          position: relative;
          margin-right: 2px;
        }

        &::after {
          content: "";
          position: absolute;
          top: 50%;
          left: 50%;
          transform: translateX(-50%) translateY(-50%);
          width: 100%;
          height: calc(100% + 10px);
          padding: 0 70%;
          z-index: -1;
          background: url("./images/矩形@2x.png") no-repeat;
          background-size: 100% 100%;
        }
      }
    }
  }

  .contextmenu {
    margin: 0;
    background: #fff;
    z-index: 3000;
    position: absolute;
    list-style-type: none;
    padding: 5px 0;
    border-radius: 4px;
    font-size: 12px;
    font-weight: 400;
    color: #333;
    box-shadow: 2px 2px 3px 0 rgba(0, 0, 0, 0.3);

    li {
      margin: 0;
      padding: 7px 16px;
      cursor: pointer;

      &:hover {
        background: #eee;
      }
    }
  }
}
</style>

<style lang="scss">
//reset element css of el-icon-close
.tags-view-wrapper {
  .tags-view-item {
    color: #333;

    .el-icon-close {
      width: 16px;
      height: 16px;
      vertical-align: 2px;
      border-radius: 50%;
      text-align: center;
      transition: all 0.3s cubic-bezier(0.645, 0.045, 0.355, 1);
      transform-origin: 100% 50%;
      margin-right: 5px;
      &:before {
        // transform: scale(0.6);
        display: inline-block;
        vertical-align: -2px;
      }

      &:hover {
        background-color: #b4bccc;
        color: #fff;
      }
    }
    .el-icon-close-else {
      width: 16px;
      height: 16px;
      vertical-align: 2px;
      border-radius: 50%;
      text-align: center;
      transition: all 0.3s cubic-bezier(0.645, 0.045, 0.355, 1);
      transform-origin: 100% 50%;

      &:before {
        display: inline-block;
        vertical-align: -2px;
      }
    }
  }
}
</style>
